;settings
!include "Settings.nsh"

;functions for functions
!include "InternalFunctions.nsh"
!include "un_InternalFunctions.nsh"

;x64 bit check (needed for GRUB install on vista/7)
!include "x64.nsh"

;functions for installing and configuring GRUB
!include "\mnt\sdc2\PuppyLinuxInstallerCreator\InstallGrubFunctions.nsh"
!include "un_UninstallGrubFunctions.nsh"

;functions
!include "\mnt\sdc2\PuppyLinuxInstallerCreator\Functions.nsh"
!include "un_Functions.nsh"


; MUI 2 compatible ------
!include "MUI2.nsh"

; MUI Settings
!define MUI_ABORTWARNING
;icons
!define MUI_ICON "\mnt\sdc2\PuppyLinuxInstallerCreator\PuppyLinuxInstall.ico"
!define MUI_UNICON "\mnt\sdc2\PuppyLinuxInstallerCreator\PuppyLinuxUninstall.ico"
;side image
!define MUI_WELCOMEFINISHPAGE_BITMAP "\mnt\sdc2\PuppyLinuxInstallerCreator\SideImage.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "\mnt\sdc2\PuppyLinuxInstallerCreator\SideImage.bmp"

!define MUI_PAGE_HEADER_TEXT "${PRODUCT_NAME} ${PRODUCT_VERSION}"
!define MUI_PAGE_HEADER_SUBTEXT ""

; Welcome page
!define MUI_WELCOMEPAGE_TITLE "${PRODUCT_NAME} ${PRODUCT_VERSION} Setup"
!define MUI_WELCOMEPAGE_TEXT "Dieses Programm installiert ${PRODUCT_NAME} ${PRODUCT_VERSION} auf Ihrem Computer.$\r$\n$\r$\n${PRODUCT_NAME} ${PRODUCT_VERSION} kann $\"jederzeit deinstalliert$\" werden, Ihre Windows-Installation bleibt davon unangetastet.$\r$\n$\r$\nKlicken Sie auf Install, um die Installation von ${PRODUCT_NAME} ${PRODUCT_VERSION} zu starten."
!insertmacro MUI_PAGE_WELCOME

; Instfiles page
!insertmacro MUI_PAGE_INSTFILES

; Finish page
!define MUI_FINISHPAGE_TITLE "${PRODUCT_NAME} ${PRODUCT_VERSION} wurde erfolgreich installiert!"
!define MUI_FINISHPAGE_TEXT "${PRODUCT_NAME} ${PRODUCT_VERSION} wurde erfolgreich installiert.$\r$\n$\r$\nUm ${PRODUCT_NAME} ${PRODUCT_VERSION} zu starten, klicken Sie auf ${PRODUCT_NAME} ${PRODUCT_VERSION} ausprobieren und dann auf Finish."
;reboot
!define MUI_FINISHPAGE_TEXT_REBOOT "Soll der Computer neugestartet werden, um ${PRODUCT_NAME} ${PRODUCT_VERSION} auszuprobieren?"
!define MUI_FINISHPAGE_TEXT_REBOOTNOW "${PRODUCT_NAME} ${PRODUCT_VERSION} ausprobieren."
!define MUI_FINISHPAGE_TEXT_REBOOTLATER "Jetzt nicht neustarten."
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "${PRODUCT_NAME} ${PRODUCT_VERSION}.exe"
InstallDir "C:\${INSTALL_DIR}"
RequestExecutionLevel admin

# for Vista/7
Section .onInit
call SeeIfCompatible
call CheckIfAdmin
SectionEnd

Section "MainSection" SEC01
  ;get settings from user (where and how to install)


  ;unzip 7-zip
  ;call UnpackSevenZip

  ;unzip Puppy Linux from the ISO
  call UnzipPuppy
  
  ;configure GRUB4DOS
  call InstallGrubAndConfigureMenu

  ;make readme
  call MakeReadme
  
  ;ask to reboot
  SetRebootFlag true
SectionEnd






Section -AdditionalIcons
  SetShellVarContext all
  CreateDirectory "$SMPROGRAMS\${PRODUCT_NAME} ${PRODUCT_VERSION}"
  CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME} ${PRODUCT_VERSION}\README.lnk" "$INSTDIR\readme.txt"
  CreateShortCut "$SMPROGRAMS\${PRODUCT_NAME} ${PRODUCT_VERSION}\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY_THAT_SHOWS_IN_REMOVE_PROGRAMS}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY_THAT_SHOWS_IN_REMOVE_PROGRAMS}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY_THAT_SHOWS_IN_REMOVE_PROGRAMS}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY_THAT_SHOWS_IN_REMOVE_PROGRAMS}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY_THAT_SHOWS_IN_REMOVE_PROGRAMS}" "Publisher" "${PRODUCT_PUBLISHER}"
  
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd



Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) wurde erfolgreich deinstalliert."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Möchten Sie, $(^Name) wirklich deinstallieren?" IDYES +2
  Abort
FunctionEnd



Section Uninstall
SetShellVarContext all

  call un.checkIfCompatible

  call un.deleteFiles
  
  call un.deleteGrub
  
  MessageBox MB_YESNO "Möchten Sie die Speicherdatei, StArtLPx2save-xxx.2fs, löschen?" IDNO +3
    delete "$INSTDIR\*.2fs"
    delete "$INSTDIR\*.3fs"
  
  call un.deleteLinks
  
  SetRebootFlag true
SectionEnd
